/*******************************************************************************
 * FreeAdhocUDF - copyright (c) 2004 - 2009 adhoc dataservice GmbH
 * Christoph Theuring ct / Peter Mandrella pm / Georg Horn gh
 * <http://freeadhocudf.org> eMail <help@freeadhocudf.org>
 * (bug-)reports only in forum http://freeadhocudf.org/portal 
 * or eMail to help@freeadhocudf.org
 *   
 * this file contains declarations of all functions from FreeAdhocUDF
 * include version 20090925 
 * use from FireBird 2.0 - possibility to return NULL 
 * 
 * if you use this declarations in a non UTF-8 or UNICODE_FSS database 
 *		the max lenght of CSTRING is 32766 (1 Byte per character)
 * if you use this declarations in a InterBase UNICODE_FSS database 
 *		the max lenght of CSTRING is 10922 (3 Byts per character)
 * if you use this declarations in a InterBase or FireBird UTF-8 database 
 *		the max lenght of CSTRING is 8191 (max 4 Byts per character)
 * All declarations in this file are set to CSTRING(8191)
 * if you want to use one UDF more times in one piped string or one SQL, 
 * the sum of CSTRING of the used UDF doesn't grow over the max of your database
 *
 * Functions in groups and alphabetical order
 *
 * This file is part of FreeAdhocUDF.
 * FreeAdhocUDF is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * FreeAdhocUDF is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with FreeAdhocUDF.  If not, see <http://www.gnu.org/licenses/>. 
*******************************************************************************/

SET SQL DIALECT 3;

/******************************************************************************/
/****                User Defined Functions - BLOb Functions               ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_BLOB2EXCEL
    BLOB NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'excelblob' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBASPCHAR
    BLOB NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'blobaspchar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBCAT
    BLOB NULL,
    BLOB NULL,
    BLOB
    RETURNS PARAMETER 3
    ENTRY_POINT 'blobcat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBCATSTR
    BLOB NULL,
    CSTRING(8191) NULL,
    BLOB
    RETURNS PARAMETER 3
    ENTRY_POINT 'blobcatstr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBCMP
    BLOB NULL,
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'b_strcmp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBCOMPARE
    BLOB NULL,
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobcompare' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBLEFT
    BLOB NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'blobleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBLINE
    BLOB NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'blobline' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBLINECOUNT
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'bloblinecount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBMAXSEGMENTLENGTH
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobmaxsegmentlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBMID
    BLOB NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'blobmid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBREPLACESTRING
    BLOB NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL,
    BLOB
    RETURNS PARAMETER 6
    ENTRY_POINT 'blobreplacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBRIGHT
    BLOB NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'blobright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBSEGMENTCOUNT
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobsegmentcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBSIZE
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobsize' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBSTRPOS
    CSTRING(8191) NULL,
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'b_strpos' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBSUBSTR
    BLOB NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobsubstr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBTEXTPOS
    CSTRING(8191) NULL,
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'b_textpos' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBWORDCOUNT
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobwordcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RBLOBMID
    BLOB NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'r_blobmid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRBLOB
    CSTRING(8191) NULL,
    BLOB
    RETURNS PARAMETER 2
    ENTRY_POINT 'strblob' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****            User Defined Functions - checksum functions               ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_2OF5
    CSTRING(255) NULL
    RETURNS CSTRING(250) FREE_IT
    ENTRY_POINT 'twooffive' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_2OF5CHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'twooffivecheck' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CODE39
    CSTRING(255) NULL
    RETURNS CSTRING(250) FREE_IT
    ENTRY_POINT 'code39' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CODE39CHECK
    CSTRING(255) NULL
    RETURNS CSTRING(250) FREE_IT
    ENTRY_POINT 'code39check' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CROSSDIFF
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'crossdiff' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CROSSSUM
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'crosssum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCRYPTMD5
    CSTRING(128) NULL
    RETURNS CSTRING(33) FREE_IT
    ENTRY_POINT 'encryptmd5' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GTIN13
    CSTRING(255) NULL
    RETURNS CSTRING(13) FREE_IT
    ENTRY_POINT 'gtin13' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GTIN13CHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'gtin13check' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GTIN14
    CSTRING(255) NULL
    RETURNS CSTRING(14) FREE_IT
    ENTRY_POINT 'gtin14' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GTIN14CHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'gtin14check' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GTIN8
    CSTRING(255) NULL
    RETURNS CSTRING(8) FREE_IT
    ENTRY_POINT 'gtin8' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GTIN8CHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'gtin8check' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISBN10
    CSTRING(255) NULL
    RETURNS CSTRING(13) FREE_IT
    ENTRY_POINT 'isbn10' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISBN10CHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'isbn10check' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISBN13
    CSTRING(255) NULL
    RETURNS CSTRING(17) FREE_IT
    ENTRY_POINT 'isbn13' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISBN13CHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'isbn13check' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISSN8
    CSTRING(255) NULL
    RETURNS CSTRING(9) FREE_IT
    ENTRY_POINT 'issn8' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISSN8CHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'issn8check' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ITERATECROSSSUM
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'iteratecrosssum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NVE18
    CSTRING(255) NULL
    RETURNS CSTRING(18) FREE_IT
    ENTRY_POINT 'nve18' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NVE18CHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'nve18check' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UPC12
    CSTRING(255) NULL
    RETURNS CSTRING(12) FREE_IT
    ENTRY_POINT 'upc12' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UPC12CHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'upc12check' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UPSTN
    CSTRING(255) NULL
    RETURNS CSTRING(21) FREE_IT
    ENTRY_POINT 'upstn' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UPSTNCHECK
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'upstncheck' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEIGHTCROSSSUM
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weightcrosssum' MODULE_NAME 'FreeAdhocUDF';
    
/******************************************************************************/
/****              User Defined Functions - constant functions             ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_C
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'c' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_E
    RETURNS DOUBLE PRECISION BY VALUE
    ENTRY_POINT 'euler' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_G
    RETURNS DOUBLE PRECISION BY VALUE
    ENTRY_POINT 'g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_K
    RETURNS DOUBLE PRECISION BY VALUE
    ENTRY_POINT 'k' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PI
    RETURNS DOUBLE PRECISION BY VALUE
    ENTRY_POINT 'pi' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARABIC2ROMAN
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'arabic2roman' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTFROM33
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'convertfrom33' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTFROMBASE
    CSTRING(255) NULL,
    INTEGER NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'convertfrombase' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTTO33
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'convertto33' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTTOBASE
    INTEGER NULL,
    INTEGER NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'converttobase' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_AC2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ac2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_AR2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ar2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_BAR2PA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'bar2pa' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_BAR2TORR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'bar2torr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_BBL2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'bbl2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_BHP2KW
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'bhp2kw' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_C2F
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'c2f' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CAL2J
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cal2j' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CBL2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cbl2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CBM2RT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cbm2rt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CH2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ch2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CT2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ct2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUB2CUYD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cum2cuyd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUFT2CUB
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cuft2cum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUIN2CUM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cuin2cum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUM2CUFT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cum2cuft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUM2CUIN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cum2cuin' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUP2ML
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cup2ml' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUYD2CUB
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cuyd2cub' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CWT2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cwt2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_DECTIME2TIME
    DOUBLE PRECISION NULL
    RETURNS TIME FREE_IT
    ENTRY_POINT 'dectime2time' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_DRA2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'dra2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_F2C
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f2c' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_FM2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fm2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_FPS2MPS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fps2mps' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_FT2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ft2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_FUR2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fur2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2CT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2ct' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2CWT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2cwt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2DRA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2dra' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2OBU
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2obu' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2OZ
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2oz' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2OZTR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2oztr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2ST
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2st' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2T
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2t' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_GBBU2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'gbbu2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_GBFLOZ2ML
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'gbfloz2ml' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_GBGAL2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'gbgal2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_GBPT2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'gbpt2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_GBQT2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'gbqt2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_HA2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ha2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_IN2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'in2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_INDTIME2TIME
    DOUBLE PRECISION NULL
    RETURNS TIME FREE_IT
    ENTRY_POINT 'indtime2time' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_J2CAL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'j2cal' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KG2LB
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'kg2lb' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KM2LEA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'km2lea' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KM2MILE
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'km2mile' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KM2SM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'km2sm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KMPH2MPH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'kmph2mph' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KMPH2SMPH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'kmph2smph' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KW2BHP
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'kw2bhp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KW2PS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'kw2ps' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L100KM2MPGBGAL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mpgbgal2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L100KM2MPUSGAL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mpusgal2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2BBL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2bbl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2GBBU
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2gbbu' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2GBGAL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2gbgal' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2GBPT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2gbpt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2GBQT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2gbqt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2USBU
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2usbu' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2USGAL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2usgal' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2USPT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2uspt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2USQT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2usqt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_LB2KG
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'lb2kg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_LBFT2NM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'lbft2nm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_LEA2KM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'lea2km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_LI2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'li2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2CBL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2cbl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2CH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2ch' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2FM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2fm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2FT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2ft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2FUR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2fur' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2IN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2in' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2LI
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2li' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2NL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2nl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2NM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2nm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2RD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2rd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2SHOT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2shot' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2YD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2yd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MILE2KM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mile2km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_ML2CUP
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ml2cup' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_ML2GBFLOZ
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ml2gbfloz' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_ML2USFLOZ
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ml2usfloz' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MM2P
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mm2p' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MORGEN2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'morgen2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPGBGAL2L100KM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mpgbgal2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPH2KMPH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mph2kmph' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPS2FPS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mps2fps' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPUSGAL2L100KM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mpusgal2lp100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_NL2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'nl2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_NM2LBFT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'nm2lbft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_NM2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'nm2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_OBU2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'obu2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_OZ2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'oz2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_OZTR2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'oztr2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_P2MM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'p2mm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PA2BAR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'pa2bar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PA2PSI
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'pa2psi' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PA2TORR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'pa2torr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PS2KW
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ps2kw' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PSI2PA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'psi2pa' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_RD2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'rd2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_RT2CBM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'rt2cbm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SHOT2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'shot2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SM2KM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sm2km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SMPH2KMPH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'smph2kmph' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQFT2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqft2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2AC
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2ac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2AR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2ar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2HA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2ha' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2MORGEN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2morgen' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2SQFT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2sqft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2SQYD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2sqyd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQYD2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqyd2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_ST2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'st2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_T2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 't2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_TIME2DECTIME
    TIMESTAMP NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'time2dectime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_TIME2INDTIME
    TIMESTAMP NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'time2indtime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_TORR2BAR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'torr2bar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_TORR2PA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'torr2pa' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_USBU2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'usbu2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_USFLOZ2ML
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'usfloz2ml' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_USGAL2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'usgal2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_USPT2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'uspt2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_USQT2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'usqt2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_YD2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'yd2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DEGTORAD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'degtorad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HEXTOINT
    CSTRING(20) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hextoint' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTTOHEX
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'inttohex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RADTODEG
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'radtodeg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROMAN2ARABIC
    CSTRING(50) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'roman2arabic' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                User Defined Functions - Date and Time functions      ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ADDDAY
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDHOUR
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addhour' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDMINUTE
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addminute' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDMONTH
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDPERIOD
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'addperiod' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDSECOND
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addsecond' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDWEEK
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDYEAR
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINDAYS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageindaysnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINDAYSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageindaysthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINHOURS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinhoursnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINHOURSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinhoursthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMINUTES
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinminutesnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMINUTESTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinminutesthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMONTHS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinmonthsnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMONTHSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinmonthsthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINSECONDS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinsecondsnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINSECONDSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinsecondsthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSISO
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksnulliso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSTHRESHOLDISO
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksthresholdnulliso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWORKINGDAYS
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinworkingdays' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWORKINGDAYSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinworkingdaysthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINYEARS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinyearsnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINYEARSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinyearsthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ASCHERMITTWOCH
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'aschermittwoch' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWLONG
    TIMESTAMP NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWLONGLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWSHORT
    TIMESTAMP NULL
    RETURNS CSTRING(4) FREE_IT
    ENTRY_POINT 'cdowshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWSHORTLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHLONG
    TIMESTAMP NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHLONGLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHSHORT
    TIMESTAMP NULL
    RETURNS CSTRING(4) FREE_IT
    ENTRY_POINT 'cmonthshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHSHORTLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COUNTWEEKDAYS
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'countweekdays' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DATETODOUBLE
    TIMESTAMP NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'datetodouble' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DATETOSTR
    TIMESTAMP NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'datetostr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DATETOSTRLANG
    TIMESTAMP NULL,
    CSTRING(255) NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'datetostrlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFMONTH
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFWEEK
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFYEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'daysbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYSOFMONTH
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'daysofmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLETODATE
    DOUBLE PRECISION NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'doubletodate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLETOTIME
    DOUBLE PRECISION NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'doubletotime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOW
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_dow' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DTIME
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dtime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODEDATE
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'encodedate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODETIME
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIME FREE_IT
    ENTRY_POINT 'encodetime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODETIMESTAMP
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'encodetimestamp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALDATE
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equaldate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALDATETIME
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equaldatetime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EXTRACTWEEKDAY
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_weekday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EXTRACTYEARDAY
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_yearday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYKW
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaykw' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYLASTMONTH
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaylastmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYLASTQUARTER
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaylastquarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYLASTWEEK
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaylastweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYLASTWEEKISO
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaylastweekiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYMONTH
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaymonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYNEXTMONTH
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaynextmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYNEXTQUARTER
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaynextquarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYNEXTWEEK
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaynextweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYNEXTWEEKISO
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaynextweekiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYQUARTER
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdayquarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYWEEK
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdayweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYWEEKISO
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdayweekiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYWOY
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'firstdaywoy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FRONLEICHNAM
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'fronleichnam' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GFORMATD
    CSTRING(255) NULL,
    TIMESTAMP NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'gformatd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GRUENDONNERSTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'gruendonnerstag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HIMMELFAHRT
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'himmelfahrt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOUR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hour' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOURSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hoursbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INCDATE
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'incdate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INCDATETIME
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'incdatetime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INDMINUTESBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'indminutesbetween' MODULE_NAME 'FreeAdhocUDF';

/* for FireBird */
DECLARE EXTERNAL FUNCTION F_INDMINUTESBETWEENTHR
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    TIME NULL,
    INTEGER NULL,
    TIME NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'indminutesbetweenthr' MODULE_NAME 'FreeAdhocUDF';

/* for InterBase 
DECLARE EXTERNAL FUNCTION F_INDMINUTESBETWEENTHR
    TIMESTAMP,
    TIMESTAMP,
    TIMESTAMP,
    INTEGER,
    TIMESTAMP,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'indminutesbetweenthrib' MODULE_NAME 'FreeAdhocUDF'
*/    
DECLARE EXTERNAL FUNCTION F_ISLEAPYEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'isleapyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_KALENDERWOCHE
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'kalenderwoche' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_KARFREITAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'karfreitag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_KARNEVALSDIENSTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'karnevalsdienstag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAY
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'lastday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYKW
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaykw' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYLASTMONTH
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaylastmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYLASTQUARTER
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaylastquarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYLASTWEEK
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaylastweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYLASTWEEKISO
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaylastweekiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYMONTH
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaymonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYNEXTMONTH
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaynextmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYNEXTQUARTER
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaynextquarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYNEXTWEEK
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaynextweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYNEXTWEEKISO
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaynextweekiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYQUARTER
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdayquarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYWEEK
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdayweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYWEEKISO
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdayweekiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYWOY
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'lastdaywoy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAXDATE
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'maxdate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MILLISECOND
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'millisecond' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINDATE
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'mindate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINUTE
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'minute' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINUTESBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'minutesbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MONTH
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'month' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MONTHSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'monthsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERDATUM
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'osterdatum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERMONTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'ostermontag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERSAMSTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'ostersamstag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PALMSONNTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'palmsonntag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PERIOD2SECONDS
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'period2seconds' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PFINGSTMONTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'pfingstmontag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PFINGSTSONNTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'pfingstsonntag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_QUARTER
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'quarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RENCODEDATE
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'r_encodedate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RENCODEDATETIME
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'r_encodedatetime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RISLEAPYEAR
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_isleapyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROSENMONTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'rosenmontag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECOND
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'second' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECONDS2PERIOD
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'seconds2period' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECONDSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'secondsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPDATE
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'stripdate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPTIME
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'striptime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRTOTIME
    CSTRING(11) NULL
    RETURNS TIME FREE_IT
    ENTRY_POINT 'strtotime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SUBPERIOD
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'subperiod' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TIMETODOUBLE
    TIMESTAMP NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'timetodouble' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEK
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'week' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKOFYEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weekofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weeksbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKSBETWEENISO
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weeksbetweeniso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEIBERFASTNACHT
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'weiberfastnacht' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WORKINGDAYSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'workingdaysbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WOY
    TIMESTAMP NULL
    RETURNS CSTRING(8) FREE_IT
    ENTRY_POINT 'woy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WOYISO
    TIMESTAMP NULL
    RETURNS CSTRING(6) FREE_IT
    ENTRY_POINT 'woyiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'year' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEAROFYEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'yearofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEARSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'yearsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ZEITDIFFERENZ
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    CSTRING(1) NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zeitdifferenz' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****            User Defined Functions - numeric/math functions           ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ABS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'doubleabs' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ACOS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccos_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ACOT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccot_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCCOSD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccos_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCCOTD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccot_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCOSH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcosh' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCOTH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcoth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCSIND
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcsin_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCTAND
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arctan_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARSINH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arsinh' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARTANH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'artanh' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ASIN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcsin_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ATAN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arctan_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ATAN2
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arctan2_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_AND
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_and' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_GET
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_getbit' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_NOT
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_not' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_OR
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_or' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_SET
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_setbit' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_SHL
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_shl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_SHR
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_shr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_XOR
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_xor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CEILING
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_ceiling' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cos_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COSD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cos_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COSH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'coshyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cot_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COTD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cot_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COTH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cothyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DIV
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_div' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOLLARVAL
    DOUBLE PRECISION NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'dollarval' MODULE_NAME 'FreeAdhocUDF';    

DECLARE EXTERNAL FUNCTION F_DOUBLEABS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'doubleabs' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLERANDOM
    INTEGER NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'doublerandom' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DZERO
    DOUBLE PRECISION,
    DOUBLE PRECISION,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION BY VALUE
    ENTRY_POINT 'r_dividezero' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALFLOAT
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalfloat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALINTEGER
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalinteger' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EUROVAL
    DOUBLE PRECISION NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'euroval' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EVEN
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'evenodd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EXP
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_exp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FACT
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fact' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FACTORIAL
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fact' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIXEDPOINT
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'fixedpoint' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIXEDPOINTLANG
    DOUBLE PRECISION NULL,
    INTEGER NULL,
    CSTRING(1) NULL,
    CSTRING(1) NULL
    RETURNS CSTRING(25) FREE_IT
    ENTRY_POINT 'fixedpointlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FLOOR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_floor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FRAC
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_frac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GETRANDOM
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'getrandom' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INPUTVAL
    DOUBLE PRECISION NULL,
    CSTRING(10) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'inputval' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTEGERABS
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'integerabs' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTRANDOM
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'intrandom' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISDIVISIBLEBY
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'isdivisibleby' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_ln' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOG
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_log' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOG10
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_log10' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAX
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'maxnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAXNUM
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'maxnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MIN
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'minnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINNUM
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'minnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MODULO
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'modulo' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NUMINWORDS
    DOUBLE PRECISION NULL,
    SMALLINT NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'numinwords' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_POWER
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_power' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PROZENTE
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'prozente' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RAND
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_rand' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUND
    DOUBLE PRECISION NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_round' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUNDCOMMON
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zahlrunden' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUNDFLOAT
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'roundfloat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUNDTOEVEN
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'roundtoeven' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SIGN
    DOUBLE PRECISION NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_sign' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SIN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sin_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SIND
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sin_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SINH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sinhyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SOFTROUND
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'softround' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SQRT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_sqrt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tan_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAND
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tan_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TANH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tanhyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TRUNCATE
    DOUBLE PRECISION NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_truncate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_Z
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION BY VALUE
    ENTRY_POINT 'r_z' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ZAHLRUNDEN
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zahlrunden' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                   User Defined Functions - other functions           ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_DNVL
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'dnvl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DNVL2
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'dnvl2' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_IF
    CSTRING(32) NULL,
    CSTRING(8) NULL,
    CSTRING(32) NULL,
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'aif' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INVL
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'invl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INVL2
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'invl2' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SNVL
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'snvl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SNVL2
    CSTRING(8191) NULL,
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'snvl2' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_VERSION
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'version' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                   User Defined Functions - string functions          ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ANSILOWERCASE
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ANSIUPPERCASE
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'upper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLEFT
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLRTRIM
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLTRIM
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'ltrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGMID
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGREPLACE
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGREPLACESTRING
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGRIGHT
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGRTRIM
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'rtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRINGLENGTH
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRIPSTRING
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRIPSTRINGHOLD
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with Delphi FreeUDFLib
*  to use please uncomment it and comment the following version
* 
*DECLARE EXTERNAL FUNCTION F_BIGSUBSTR
*    CSTRING(255) NULL,
*    CSTRING(8191) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsub' MODULE_NAME 'FreeAdhocUDF';
*/ 

/* Version compatible with FreeUDFLibC */
DECLARE EXTERNAL FUNCTION F_BIGSUBSTR
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CHARACTER
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CHR
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COLLATEBR
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'collatebr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTSYMBOLS
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'convertsymbols' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COPY
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'mid1' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CRLF
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'crlf' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DIGITS
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'digits' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOMAINFROMEMAIL
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'domainfromemail' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DQM

    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'dqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALSTRING
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FINDNTHWORD
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'findnthword' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FINDWORD
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'findword' MODULE_NAME 'FreeAdhocUDF';

/* version which returns -1 if not found 
*DECLARE EXTERNAL FUNCTION F_FINDWORDINDEX
*    CSTRING(8191) NULL,
*    INTEGER NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'findwordindex' MODULE_NAME 'FreeAdhocUDF';
*/
/* version which returns <null> in FB 2.0 instead of -1 if not found */
DECLARE EXTERNAL FUNCTION F_FINDWORDINDEX
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'findwordindexnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FLOATTOSTR
    DOUBLE PRECISION NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'floattostr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GENERATESNDXINDEX
    CSTRING(8191) NULL
    RETURNS CSTRING(6) FREE_IT
    ENTRY_POINT 'soundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GSOUNDEX
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'gsoundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOLDSTRING
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTTOSTR
    INTEGER NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'inttostr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_KEYUP
    CSTRING(8191) NULL,
    SMALLINT NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'keyup' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT
    CSTRING(255) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT8
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LF
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'lf' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LINEWRAP
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'linewrap' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOWER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM8
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'ltrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM8
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID4
    CSTRING(4095) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID8
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NBSP
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'nbsp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ORD
    CSTRING(1) NULL
    RETURNS SMALLINT FREE_IT
    ENTRY_POINT 'ord' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADCENTER
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padcenter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADLEFT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADRIGHT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PRED
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'predecessor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PROPERCASE
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'propercase' MODULE_NAME 'FreeAdhocUDF';

/* this is correct WITHOUT NULL because of the sence of the function */
DECLARE EXTERNAL FUNCTION F_RC
    CSTRING(255)
    RETURNS CSTRING(255)
    ENTRY_POINT 'r_c' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPEATTRIM
    CSTRING(8191) NULL,
    CSTRING(1) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'repeattrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE4
    CSTRING(4095) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE8
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING4
    CSTRING(4095) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING8
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REVERSE
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT
    CSTRING(255) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT8
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RLATIN
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'rlatin' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RLOWER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'rlower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROT13
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'rot13' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RPADLEFT
    CSTRING(4095) NULL,
    INTEGER NULL,
    CSTRING(16) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'r_padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RPADRIGHT
    CSTRING(4095) NULL,
    INTEGER NULL,
    CSTRING(16) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'r_padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RSTRINGCOUNT
    CSTRING(255) NULL,
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_stringcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'rtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM8
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RUPPER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'rupper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RWORDCOUNT
    CSTRING(8191) NULL,
    CSTRING(31) NULL,
    SMALLINT NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_wordcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SOUNDEX
    CSTRING(8191) NULL
    RETURNS CSTRING(6) FREE_IT
    ENTRY_POINT 'soundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SPACE
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'space' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SQM
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STR2EXCEL
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'excelstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRCMP
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_strcmp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRCOPY
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strcopy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGCOUNT
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH4
    CSTRING(4095) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH8
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLISTITEM
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(1024) FREE_IT
    ENTRY_POINT 'stringlistitem' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING4
    CSTRING(4095) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING8
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD4
    CSTRING(4095) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD8
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STROFCHAR
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strofchar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRPOS
    CSTRING(255) NULL,
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'strpos' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRREPEAT
    CSTRING(255) NULL,
    SMALLINT NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strrepeat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRRM
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strrm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRSTUFF
    CSTRING(8191) NULL,
    SMALLINT NULL,
    SMALLINT NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strstuff' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with Delphi FreeUDFLib
*  to use please uncomment it and comment the following version
* 
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(255) NULL,
*    CSTRING(255) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsub' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with Delphi FreeUDFLib and NULL
*  to use please uncomment it and comment the following version
* 
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(255) NULL,
*    CSTRING(255) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsubnull' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC 
*  to use please uncomment it and comment the following version
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(255) NULL,
*    CSTRING(255) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'substr' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR4
    CSTRING(4095) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR8
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SUCC
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'successor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAB
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'tab' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TELEFONNR
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'telefonnr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UPPER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'upper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WORDCOUNT
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'wordcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WORDNUM
    CSTRING(8191) NULL,
    INTEGER NULL,
    CSTRING(31) NULL,
    SMALLINT NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'wordnum' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****               User Defined Functions: utf-8 functions                ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION U_CHR
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'u_character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_CONVERTSYMBOLS
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_convertsymbols' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_CYRILLIC_LATIN
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_cyrillic_latin' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_FINDWORD
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_findword' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LEFT
    CSTRING(255) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LEFT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LEFT8
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LINEWRAP
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_linewrap' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_LOWER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MID
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MID4
    CSTRING(4095) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MID8
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_ORD
    CSTRING(1) NULL
    RETURNS SMALLINT FREE_IT
    ENTRY_POINT 'u_ord' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PADCENTER
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_padcenter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PADLEFT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PADRIGHT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PRED
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'u_predecessor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_PROPERCASE
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_propercase' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REPEATTRIM
    CSTRING(8191) NULL,
    CSTRING(1) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_repeattrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REPLACESTRING
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REPLACESTRING4
    CSTRING(4095) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REPLACESTRING8
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REVERSE
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REVERSE4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_REVERSE8
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_RIGHT
    CSTRING(255) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_RIGHT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_RIGHT8
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRCMP
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_rstrcmp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRINGLENGTH
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRINGLENGTH4
    CSTRING(4095) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRINGLENGTH8
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRING
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRING4
    CSTRING(4095) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRING8
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRINGHOLD
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'u_stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRINGHOLD4
    CSTRING(4095) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'u_stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRIPSTRINGHOLD8
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRRM
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_strrm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_STRSTUFF
    CSTRING(8191) NULL,
    SMALLINT NULL,
    SMALLINT NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_strstuff' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_SUBSTR
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_SUBSTR4
    CSTRING(4095) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_SUBSTR8
    CSTRING(8091) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'u_substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_SUCC
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'u_successor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_UPPER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'u_upper' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                User Defined Functions: UUID functions                ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_UUID1COMPRTIMESTAMP
    CSTRING(255) NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'uuid1comprtimestamp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MAC
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'uuid1mac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MACCOMPR
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'uuid1maccompr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MACCOMPRMAC
    CSTRING(255) NULL
    RETURNS CSTRING(18) FREE_IT
    ENTRY_POINT 'uuid1maccomprmac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MACMAC
    CSTRING(255) NULL
    RETURNS CSTRING(18) FREE_IT
    ENTRY_POINT 'uuid1macmac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1RAND
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'uuid1rand' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1RANDCOMPR
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'uuid1randcompr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1TIMESTAMP
    CSTRING(255) NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'uuid1timestamp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID2UUIDCOMPR
    CSTRING(255) NULL
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'compressuuid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID4
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'uuid4' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID4COMPR
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'uuid4compr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUIDCOMPR2UUID
    CSTRING(255) NULL
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'expanduuidcompr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUIDVERSION
    CSTRING(255) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'uuidversion' MODULE_NAME 'FreeAdhocUDF';

/* adhoc 2009-09-21 */  

DECLARE EXTERNAL FUNCTION F_DSQM
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'dsqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RAPPENRUNDUNG
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'rappenrundung' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MONTHLONG
    TIMESTAMP NULL
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_monthlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MONTHSHORT
    TIMESTAMP NULL
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'u_monthshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DOWLONG
    TIMESTAMP NULL
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_dowlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DOWSHORT
    TIMESTAMP NULL
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'u_dowshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DATE2STRLANG
    TIMESTAMP NULL,
    CSTRING(250) NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(250) FREE_IT
    ENTRY_POINT 'u_date2strlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MONTHLONGLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_monthlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_MONTHSHORTLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'u_monthshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DOWLONGLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(20) FREE_IT
    ENTRY_POINT 'u_dowlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION U_DOWSHORTLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'u_dowshortlang' MODULE_NAME 'FreeAdhocUDF';

/* adhoc 2010-11-06 */
