/*******************************************************************************
 * FreeAdhocUDF - copyright (c) 2004 - 2009 adhoc dataservice GmbH
 * Christoph Theuring ct / Peter Mandrella pm / Georg Horn gh
 * <http://freeadhocudf.org> eMail <help@freeadhocudf.org>
 * (bug-)reports only in forum http://freeadhocudf.org/portal 
 * or eMail to help@freeadhocudf.org
 *   
 * this file contains declarations of other functions from FreeAdhocUDF
 *
 * if you use this declarations in a non UTF-8 or UNICODE_FSS database 
 *		the max lenght of CSTRING is 32766 (1 Byte per character)
 * if you use this declarations in a InterBase UNICODE_FSS database 
 *		the max lenght of CSTRING is 10922 (3 Byts per character)
 * if you use this declarations in a InterBase or FireBird UTF-8 database 
 *		the max lenght of CSTRING is 8191 (max 4 Byts per character)
 * All declarations in this file are set to CSTRING(8191)
 * if you want to use one UDF more times in one piped string or one SQL, 
 * the sum of CSTRING of the used UDF doesn't grow over the max of your database
 *
 * Functions in alphabetical order
 *
 * This file is part of FreeAdhocUDF.
 * FreeAdhocUDF is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * FreeAdhocUDF is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with FreeAdhocUDF.  If not, see <http://www.gnu.org/licenses/>. 
*******************************************************************************/

SET SQL DIALECT 3;

/******************************************************************************/
/****                   User Defined Functions - other functions           ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_DNVL
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'dnvl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DNVL2
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'dnvl2' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_IF
    CSTRING(32) NULL,
    CSTRING(8) NULL,
    CSTRING(32) NULL,
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'aif' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INVL
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'invl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INVL2
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'invl2' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SNVL
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'snvl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SNVL2
    CSTRING(8191) NULL,
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'snvl2' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_VERSION
    RETURNS CSTRING(30) FREE_IT
    ENTRY_POINT 'version' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_VERSIONNAME
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'versionname' MODULE_NAME 'FreeAdhocUDF';
    
/* adhoc 2010-11-23 */
